#include "libclient.hh"

#include <ncurses.h>
#include <boost/asio.hpp>

using namespace boost::asio;
io_service io;
ip::tcp::socket s(io);

bool canChange;

void run(const std::string& host, const std::string& port)
{
  ip::tcp::resolver resolver(io);
  ip::tcp::resolver::query query(host, port);
  ip::tcp::resolver::iterator endpoint_iterator = resolver.resolve(query);

  connect(s, endpoint_iterator);
  
  init_pair(1, COLOR_RED, COLOR_BLACK);
  init_pair(2, COLOR_GREEN, COLOR_BLACK);
  init_pair(4, COLOR_BLUE, COLOR_BLACK);
  init_pair(3, COLOR_YELLOW, COLOR_BLACK);
  init_pair(5, COLOR_MAGENTA, COLOR_BLACK);
  init_pair(6, COLOR_CYAN, COLOR_BLACK);
  init_pair(7, COLOR_WHITE, COLOR_BLACK);
  init_pair(8, COLOR_BLACK, COLOR_BLACK);
  while (true)
  {
    write(s, buffer("dump\n", 5));
    streambuf reply;
    std::vector<ptrim::DeviceColor> cols;
    while (true)
    {
      read_until(s, reply, "\n");
      std::string line;
      std::istream response_stream(&reply);
      std::getline(response_stream, line);
      if (line.empty())
        break;
      cols.push_back(ptrim::DeviceColor(line, 255));
    }
    for (unsigned d=0; d<cols.size(); ++d)
    {
      move(d, 0);
      ptrim::DeviceColor& dc = cols[d];
      for (unsigned i=0; i<8; ++i)
      {
        ptrim::RGB& c = dc.colors[i];
        if (canChange)
        {
          init_color(COLOR_RED, c.r * 1000/256, c.g*1000/256, c.b*1000/256);
          attron(COLOR_PAIR(1));
          addch('*');
          attroff(COLOR_PAIR(1));
        }
        else
        {
          int cv = ((c.r > 0x80)? 1:0)
           + ((c.g > 0x80)? 2:0) + ((c.b > 0x80)? 4:0);
           attron(COLOR_PAIR(cv?cv:8));
           addch('*');
           attroff(COLOR_PAIR(cv?cv:8));
        }
      }
    }
    refresh();
    usleep(10000);
  }
}


int main(int argc, char** argv)
{
  initscr();
  start_color();
  if (COLOR_PAIRS < 9)
    throw std::runtime_error("Not enough color pairs");
  canChange = can_change_color();
  run(argv[1], argv[2]);
}
